class ConvTranspose1d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  in_channels : int
  out_channels : int
  kernel_size : Tuple[int]
  stride : Tuple[int]
  padding : Tuple[int]
  dilation : Tuple[int]
  transposed : bool
  output_padding : Tuple[int]
  groups : int
  padding_mode : str
  _packed_params : __torch__.torch.classes.quantized.Conv2dPackedParamsBase
  scale : float
  zero_point : int
  def forward(self: __torch__.torch.nn.quantized.modules.conv.ConvTranspose1d,
    input: Tensor) -> Tensor:
    _0 = torch.ne(torch.len(torch.size(input)), 3)
    if _0:
      ops.prim.RaiseException("Input shape must be `(N, C, L)`!")
    else:
      pass
    _packed_params = self._packed_params
    scale = self.scale
    zero_point = self.zero_point
    _1 = ops.quantized.conv_transpose1d(input, _packed_params, scale, zero_point)
    return _1
  def __getstate__(self: __torch__.torch.nn.quantized.modules.conv.ConvTranspose1d) -> Tuple[int, int, Tuple[int], Tuple[int], Tuple[int], Tuple[int], bool, Tuple[int], int, str, Tensor, Optional[Tensor], float, int, bool]:
    w, b, = (self)._weight_bias()
    in_channels = self.in_channels
    out_channels = self.out_channels
    kernel_size = self.kernel_size
    stride = self.stride
    padding = self.padding
    dilation = self.dilation
    transposed = self.transposed
    output_padding = self.output_padding
    groups = self.groups
    padding_mode = self.padding_mode
    scale = self.scale
    zero_point = self.zero_point
    training = self.training
    _2 = (in_channels, out_channels, kernel_size, stride, padding, dilation, transposed, output_padding, groups, padding_mode, w, b, scale, zero_point, training)
    return _2
  def __setstate__(self: __torch__.torch.nn.quantized.modules.conv.ConvTranspose1d,
    state: Tuple[int, int, Tuple[int], Tuple[int], Tuple[int], Tuple[int], bool, Tuple[int], int, str, Tensor, Optional[Tensor], float, int, bool]) -> NoneType:
    self.in_channels = (state)[0]
    self.out_channels = (state)[1]
    self.kernel_size = (state)[2]
    self.stride = (state)[3]
    self.padding = (state)[4]
    self.dilation = (state)[5]
    self.transposed = (state)[6]
    self.output_padding = (state)[7]
    self.groups = (state)[8]
    self.padding_mode = (state)[9]
    _3 = (self).set_weight_bias((state)[10], (state)[11], )
    self.scale = (state)[12]
    self.zero_point = (state)[13]
    self.training = (state)[14]
    return None
  def _weight_bias(self: __torch__.torch.nn.quantized.modules.conv.ConvTranspose1d) -> Tuple[Tensor, Optional[Tensor]]:
    _packed_params = self._packed_params
    w, b = ops.quantized.conv_transpose1d_unpack(_packed_params)
    return (w, b)
  def set_weight_bias(self: __torch__.torch.nn.quantized.modules.conv.ConvTranspose1d,
    w: Tensor,
    b: Optional[Tensor]) -> NoneType:
    stride = self.stride
    padding = self.padding
    output_padding = self.output_padding
    dilation = self.dilation
    groups = self.groups
    _4, = stride
    _5, = padding
    _6, = output_padding
    _7, = dilation
    _8 = ops.quantized.conv_transpose1d_prepack(w, b, [_4], [_5], [_6], [_7], groups)
    self._packed_params = _8
    return None
class ConvTranspose2d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  in_channels : int
  out_channels : int
  kernel_size : Tuple[int, int]
  stride : Tuple[int, int]
  padding : Tuple[int, int]
  dilation : Tuple[int, int]
  transposed : bool
  output_padding : Tuple[int, int]
  groups : int
  padding_mode : str
  _packed_params : __torch__.torch.classes.quantized.Conv2dPackedParamsBase
  scale : float
  zero_point : int
  def forward(self: __torch__.torch.nn.quantized.modules.conv.ConvTranspose2d,
    input: Tensor) -> Tensor:
    _9 = "Input shape must be `(N, C, H, W)`!"
    _10 = torch.ne(torch.len(torch.size(input)), 4)
    if _10:
      ops.prim.RaiseException(_9)
    else:
      pass
    _packed_params = self._packed_params
    scale = self.scale
    zero_point = self.zero_point
    _11 = ops.quantized.conv_transpose2d(input, _packed_params, scale, zero_point)
    return _11
  def __getstate__(self: __torch__.torch.nn.quantized.modules.conv.ConvTranspose2d) -> Tuple[int, int, Tuple[int, int], Tuple[int, int], Tuple[int, int], Tuple[int, int], bool, Tuple[int, int], int, str, Tensor, Optional[Tensor], float, int, bool]:
    w, b, = (self)._weight_bias()
    in_channels = self.in_channels
    out_channels = self.out_channels
    kernel_size = self.kernel_size
    stride = self.stride
    padding = self.padding
    dilation = self.dilation
    transposed = self.transposed
    output_padding = self.output_padding
    groups = self.groups
    padding_mode = self.padding_mode
    scale = self.scale
    zero_point = self.zero_point
    training = self.training
    _12 = (in_channels, out_channels, kernel_size, stride, padding, dilation, transposed, output_padding, groups, padding_mode, w, b, scale, zero_point, training)
    return _12
  def __setstate__(self: __torch__.torch.nn.quantized.modules.conv.ConvTranspose2d,
    state: Tuple[int, int, Tuple[int, int], Tuple[int, int], Tuple[int, int], Tuple[int, int], bool, Tuple[int, int], int, str, Tensor, Optional[Tensor], float, int, bool]) -> NoneType:
    self.in_channels = (state)[0]
    self.out_channels = (state)[1]
    self.kernel_size = (state)[2]
    self.stride = (state)[3]
    self.padding = (state)[4]
    self.dilation = (state)[5]
    self.transposed = (state)[6]
    self.output_padding = (state)[7]
    self.groups = (state)[8]
    self.padding_mode = (state)[9]
    _13 = (self).set_weight_bias((state)[10], (state)[11], )
    self.scale = (state)[12]
    self.zero_point = (state)[13]
    self.training = (state)[14]
    return None
  def _weight_bias(self: __torch__.torch.nn.quantized.modules.conv.ConvTranspose2d) -> Tuple[Tensor, Optional[Tensor]]:
    _packed_params = self._packed_params
    w, b = ops.quantized.conv2d_unpack(_packed_params)
    return (w, b)
  def set_weight_bias(self: __torch__.torch.nn.quantized.modules.conv.ConvTranspose2d,
    w: Tensor,
    b: Optional[Tensor]) -> NoneType:
    stride = self.stride
    padding = self.padding
    output_padding = self.output_padding
    dilation = self.dilation
    groups = self.groups
    _14, _15, = stride
    _16 = [_14, _15]
    _17, _18, = padding
    _19 = [_17, _18]
    _20, _21, = output_padding
    _22 = [_20, _21]
    _23, _24, = dilation
    _25 = ops.quantized.conv_transpose2d_prepack(w, b, _16, _19, _22, [_23, _24], groups)
    self._packed_params = _25
    return None
class ConvTranspose3d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  in_channels : int
  out_channels : int
  kernel_size : Tuple[int, int, int]
  stride : Tuple[int, int, int]
  padding : Tuple[int, int, int]
  dilation : Tuple[int, int, int]
  transposed : bool
  output_padding : Tuple[int, int, int]
  groups : int
  padding_mode : str
  _packed_params : __torch__.torch.classes.quantized.Conv3dPackedParamsBase
  scale : float
  zero_point : int
  def forward(self: __torch__.torch.nn.quantized.modules.conv.ConvTranspose3d,
    input: Tensor) -> Tensor:
    _26 = "Input shape must be `(N, C, T, H, W)`!"
    _27 = torch.ne(torch.len(torch.size(input)), 5)
    if _27:
      ops.prim.RaiseException(_26)
    else:
      pass
    _packed_params = self._packed_params
    scale = self.scale
    zero_point = self.zero_point
    _28 = ops.quantized.conv_transpose3d(input, _packed_params, scale, zero_point)
    return _28
  def __getstate__(self: __torch__.torch.nn.quantized.modules.conv.ConvTranspose3d) -> Tuple[int, int, Tuple[int, int, int], Tuple[int, int, int], Tuple[int, int, int], Tuple[int, int, int], bool, Tuple[int, int, int], int, str, Tensor, Optional[Tensor], float, int, bool]:
    w, b, = (self)._weight_bias()
    in_channels = self.in_channels
    out_channels = self.out_channels
    kernel_size = self.kernel_size
    stride = self.stride
    padding = self.padding
    dilation = self.dilation
    transposed = self.transposed
    output_padding = self.output_padding
    groups = self.groups
    padding_mode = self.padding_mode
    scale = self.scale
    zero_point = self.zero_point
    training = self.training
    _29 = (in_channels, out_channels, kernel_size, stride, padding, dilation, transposed, output_padding, groups, padding_mode, w, b, scale, zero_point, training)
    return _29
  def __setstate__(self: __torch__.torch.nn.quantized.modules.conv.ConvTranspose3d,
    state: Tuple[int, int, Tuple[int, int, int], Tuple[int, int, int], Tuple[int, int, int], Tuple[int, int, int], bool, Tuple[int, int, int], int, str, Tensor, Optional[Tensor], float, int, bool]) -> NoneType:
    self.in_channels = (state)[0]
    self.out_channels = (state)[1]
    self.kernel_size = (state)[2]
    self.stride = (state)[3]
    self.padding = (state)[4]
    self.dilation = (state)[5]
    self.transposed = (state)[6]
    self.output_padding = (state)[7]
    self.groups = (state)[8]
    self.padding_mode = (state)[9]
    _30 = (self).set_weight_bias((state)[10], (state)[11], )
    self.scale = (state)[12]
    self.zero_point = (state)[13]
    self.training = (state)[14]
    return None
  def _weight_bias(self: __torch__.torch.nn.quantized.modules.conv.ConvTranspose3d) -> Tuple[Tensor, Optional[Tensor]]:
    _packed_params = self._packed_params
    w, b = ops.quantized.conv3d_unpack(_packed_params)
    return (w, b)
  def set_weight_bias(self: __torch__.torch.nn.quantized.modules.conv.ConvTranspose3d,
    w: Tensor,
    b: Optional[Tensor]) -> NoneType:
    stride = self.stride
    padding = self.padding
    output_padding = self.output_padding
    dilation = self.dilation
    groups = self.groups
    _31, _32, _33, = stride
    _34 = [_31, _32, _33]
    _35, _36, _37, = padding
    _38 = [_35, _36, _37]
    _39, _40, _41, = output_padding
    _42 = [_39, _40, _41]
    _43, _44, _45, = dilation
    _46 = ops.quantized.conv_transpose3d_prepack(w, b, _34, _38, _42, [_43, _44, _45], groups)
    self._packed_params = _46
    return None
