class QFunctional(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  scale : float
  zero_point : int
  activation_post_process : __torch__.torch.nn.modules.linear.Identity
  def forward(self: __torch__.torch.nn.quantized.modules.functional_modules.QFunctional,
    x: Tensor) -> NoneType:
    _0 = "Functional is not intended to use the \'forward\'. Please use the underlying operation"
    _1 = uninitialized(NoneType)
    ops.prim.RaiseException(_0)
    return _1
  def add(self: __torch__.torch.nn.quantized.modules.functional_modules.QFunctional,
    x: Tensor,
    y: Tensor) -> Tensor:
    scale = self.scale
    zero_point = self.zero_point
    r = ops.quantized.add(x, y, scale, zero_point)
    activation_post_process = self.activation_post_process
    r0 = (activation_post_process).forward(r, )
    return r0
  def cat(self: __torch__.torch.nn.quantized.modules.functional_modules.QFunctional,
    x: List[Tensor],
    dim: int=0) -> Tensor:
    scale = self.scale
    zero_point = self.zero_point
    r = ops.quantized.cat(x, dim, scale, zero_point)
    activation_post_process = self.activation_post_process
    r1 = (activation_post_process).forward(r, )
    return r1
  def mul(self: __torch__.torch.nn.quantized.modules.functional_modules.QFunctional,
    x: Tensor,
    y: Tensor) -> Tensor:
    scale = self.scale
    zero_point = self.zero_point
    r = ops.quantized.mul(x, y, scale, zero_point)
    activation_post_process = self.activation_post_process
    r2 = (activation_post_process).forward(r, )
    return r2
  def add_relu(self: __torch__.torch.nn.quantized.modules.functional_modules.QFunctional,
    x: Tensor,
    y: Tensor) -> Tensor:
    scale = self.scale
    zero_point = self.zero_point
    r = ops.quantized.add_relu(x, y, scale, zero_point)
    activation_post_process = self.activation_post_process
    r3 = (activation_post_process).forward(r, )
    return r3
  def add_scalar(self: __torch__.torch.nn.quantized.modules.functional_modules.QFunctional,
    x: Tensor,
    y: float) -> Tensor:
    return ops.quantized.add_scalar(x, y)
  def mul_scalar(self: __torch__.torch.nn.quantized.modules.functional_modules.QFunctional,
    x: Tensor,
    y: float) -> Tensor:
    return ops.quantized.mul_scalar(x, y)
